
/*!
[config]
name: Vector store char2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global char2
kernel_name: vstore2_global
arg_out: 0 buffer char[3] 0 28 46
arg_in:  1 buffer char2[1] 28 46

[test]
name: vector store global offset char2
kernel_name: vstore2_global_offset
arg_out: 0 buffer char[5] 0 0 0  28 46
arg_in:  1 buffer char2[1] 28 46

[test]
name: vector store global char4
kernel_name: vstore4_global
arg_out: 0 buffer char[5] 0 120 155 52 202
arg_in:  1 buffer char4[1] 120 155 52 202

[test]
name: vector store global offset char4
kernel_name: vstore4_global_offset
arg_out: 0 buffer char[9] 0 0 0 0 0  120 155 52 202
arg_in:  1 buffer char4[1] 120 155 52 202

[test]
name: vector store global char8
kernel_name: vstore8_global
arg_out: 0 buffer char[9] 0 116 189 192 64 98 22 43 70
arg_in:  1 buffer char8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global offset char8
kernel_name: vstore8_global_offset
arg_out: 0 buffer char[17] 0 0 0 0 0 0 0 0 0  116 189 192 64 98 22 43 70
arg_in:  1 buffer char8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global char16
kernel_name: vstore16_global
arg_out: 0 buffer char[17] 0 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer char16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

[test]
name: vector store global offset char16
kernel_name: vstore16_global_offset
arg_out: 0 buffer char[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer char16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

!*/

kernel void vstore2_global(global char *out,
                             global char2 *in) {
    char2 tmp = in[0];
    vstore2((char2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global char *out,
                                    global char2 *in) {
    char2 tmp = (char2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global char *out,
                             global char4 *in) {
    char4 tmp = in[0];
    vstore4((char4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global char *out,
                                    global char4 *in) {
    char4 tmp = (char4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global char *out,
                             global char8 *in) {
    char8 tmp = in[0];
    vstore8((char8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global char *out,
                                    global char8 *in) {
    char8 tmp = (char8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global char *out,
                             global char16 *in) {
    char16 tmp = in[0];
    vstore16((char16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global char *out,
                                    global char16 *in) {
    char16 tmp = (char16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
