
/*!
[config]
name: Vector store float2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global float2
kernel_name: vstore2_global
arg_out: 0 buffer float[3] 0 28 46
arg_in:  1 buffer float2[1] 28 46

[test]
name: vector store global offset float2
kernel_name: vstore2_global_offset
arg_out: 0 buffer float[5] 0 0 0  28 46
arg_in:  1 buffer float2[1] 28 46

[test]
name: vector store global float4
kernel_name: vstore4_global
arg_out: 0 buffer float[5] 0 120 155 52 202
arg_in:  1 buffer float4[1] 120 155 52 202

[test]
name: vector store global offset float4
kernel_name: vstore4_global_offset
arg_out: 0 buffer float[9] 0 0 0 0 0  120 155 52 202
arg_in:  1 buffer float4[1] 120 155 52 202

[test]
name: vector store global float8
kernel_name: vstore8_global
arg_out: 0 buffer float[9] 0 116 189 192 64 98 22 43 70
arg_in:  1 buffer float8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global offset float8
kernel_name: vstore8_global_offset
arg_out: 0 buffer float[17] 0 0 0 0 0 0 0 0 0  116 189 192 64 98 22 43 70
arg_in:  1 buffer float8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global float16
kernel_name: vstore16_global
arg_out: 0 buffer float[17] 0 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer float16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

[test]
name: vector store global offset float16
kernel_name: vstore16_global_offset
arg_out: 0 buffer float[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer float16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

!*/

kernel void vstore2_global(global float *out,
                             global float2 *in) {
    float2 tmp = in[0];
    vstore2((float2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global float *out,
                                    global float2 *in) {
    float2 tmp = (float2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global float *out,
                             global float4 *in) {
    float4 tmp = in[0];
    vstore4((float4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global float *out,
                                    global float4 *in) {
    float4 tmp = (float4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global float *out,
                             global float8 *in) {
    float8 tmp = in[0];
    vstore8((float8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global float *out,
                                    global float8 *in) {
    float8 tmp = (float8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global float *out,
                             global float16 *in) {
    float16 tmp = in[0];
    vstore16((float16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global float *out,
                                    global float16 *in) {
    float16 tmp = (float16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
