
/*!
[config]
name: Vector store half2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0
require_device_extensions: cl_khr_fp16
[test]
name: vector store global half2
kernel_name: vstore2_global
arg_out: 0 buffer half[3] 0 28 46
arg_in:  1 buffer half2[1] 28 46

[test]
name: vector store global offset half2
kernel_name: vstore2_global_offset
arg_out: 0 buffer half[5] 0 0 0  28 46
arg_in:  1 buffer half2[1] 28 46

[test]
name: vector store global half4
kernel_name: vstore4_global
arg_out: 0 buffer half[5] 0 120 155 52 202
arg_in:  1 buffer half4[1] 120 155 52 202

[test]
name: vector store global offset half4
kernel_name: vstore4_global_offset
arg_out: 0 buffer half[9] 0 0 0 0 0  120 155 52 202
arg_in:  1 buffer half4[1] 120 155 52 202

[test]
name: vector store global half8
kernel_name: vstore8_global
arg_out: 0 buffer half[9] 0 116 189 192 64 98 22 43 70
arg_in:  1 buffer half8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global offset half8
kernel_name: vstore8_global_offset
arg_out: 0 buffer half[17] 0 0 0 0 0 0 0 0 0  116 189 192 64 98 22 43 70
arg_in:  1 buffer half8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global half16
kernel_name: vstore16_global
arg_out: 0 buffer half[17] 0 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer half16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

[test]
name: vector store global offset half16
kernel_name: vstore16_global_offset
arg_out: 0 buffer half[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer half16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

!*/

#pragma OPENCL EXTENSION cl_khr_fp16: enable

kernel void vstore2_global(global half *out,
                             global half2 *in) {
    half2 tmp = in[0];
    vstore2((half2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global half *out,
                                    global half2 *in) {
    half2 tmp = (half2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global half *out,
                             global half4 *in) {
    half4 tmp = in[0];
    vstore4((half4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global half *out,
                                    global half4 *in) {
    half4 tmp = (half4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global half *out,
                             global half8 *in) {
    half8 tmp = in[0];
    vstore8((half8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global half *out,
                                    global half8 *in) {
    half8 tmp = (half8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global half *out,
                             global half16 *in) {
    half16 tmp = in[0];
    vstore16((half16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global half *out,
                                    global half16 *in) {
    half16 tmp = (half16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
