
/*!
[config]
name: Vector store int2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global int2
kernel_name: vstore2_global
arg_out: 0 buffer int[3] 0 28 46
arg_in:  1 buffer int2[1] 28 46

[test]
name: vector store global offset int2
kernel_name: vstore2_global_offset
arg_out: 0 buffer int[5] 0 0 0  28 46
arg_in:  1 buffer int2[1] 28 46

[test]
name: vector store global int4
kernel_name: vstore4_global
arg_out: 0 buffer int[5] 0 120 155 52 202
arg_in:  1 buffer int4[1] 120 155 52 202

[test]
name: vector store global offset int4
kernel_name: vstore4_global_offset
arg_out: 0 buffer int[9] 0 0 0 0 0  120 155 52 202
arg_in:  1 buffer int4[1] 120 155 52 202

[test]
name: vector store global int8
kernel_name: vstore8_global
arg_out: 0 buffer int[9] 0 116 189 192 64 98 22 43 70
arg_in:  1 buffer int8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global offset int8
kernel_name: vstore8_global_offset
arg_out: 0 buffer int[17] 0 0 0 0 0 0 0 0 0  116 189 192 64 98 22 43 70
arg_in:  1 buffer int8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global int16
kernel_name: vstore16_global
arg_out: 0 buffer int[17] 0 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer int16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

[test]
name: vector store global offset int16
kernel_name: vstore16_global_offset
arg_out: 0 buffer int[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer int16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

!*/

kernel void vstore2_global(global int *out,
                             global int2 *in) {
    int2 tmp = in[0];
    vstore2((int2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global int *out,
                                    global int2 *in) {
    int2 tmp = (int2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global int *out,
                             global int4 *in) {
    int4 tmp = in[0];
    vstore4((int4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global int *out,
                                    global int4 *in) {
    int4 tmp = (int4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global int *out,
                             global int8 *in) {
    int8 tmp = in[0];
    vstore8((int8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global int *out,
                                    global int8 *in) {
    int8 tmp = (int8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global int *out,
                             global int16 *in) {
    int16 tmp = in[0];
    vstore16((int16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global int *out,
                                    global int16 *in) {
    int16 tmp = (int16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
