
/*!
[config]
name: Vector store uchar2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global uchar2
kernel_name: vstore2_global
arg_out: 0 buffer uchar[3] 0 28 46
arg_in:  1 buffer uchar2[1] 28 46

[test]
name: vector store global offset uchar2
kernel_name: vstore2_global_offset
arg_out: 0 buffer uchar[5] 0 0 0  28 46
arg_in:  1 buffer uchar2[1] 28 46

[test]
name: vector store global uchar4
kernel_name: vstore4_global
arg_out: 0 buffer uchar[5] 0 120 155 52 202
arg_in:  1 buffer uchar4[1] 120 155 52 202

[test]
name: vector store global offset uchar4
kernel_name: vstore4_global_offset
arg_out: 0 buffer uchar[9] 0 0 0 0 0  120 155 52 202
arg_in:  1 buffer uchar4[1] 120 155 52 202

[test]
name: vector store global uchar8
kernel_name: vstore8_global
arg_out: 0 buffer uchar[9] 0 116 189 192 64 98 22 43 70
arg_in:  1 buffer uchar8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global offset uchar8
kernel_name: vstore8_global_offset
arg_out: 0 buffer uchar[17] 0 0 0 0 0 0 0 0 0  116 189 192 64 98 22 43 70
arg_in:  1 buffer uchar8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global uchar16
kernel_name: vstore16_global
arg_out: 0 buffer uchar[17] 0 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer uchar16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

[test]
name: vector store global offset uchar16
kernel_name: vstore16_global_offset
arg_out: 0 buffer uchar[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer uchar16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

!*/

kernel void vstore2_global(global uchar *out,
                             global uchar2 *in) {
    uchar2 tmp = in[0];
    vstore2((uchar2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global uchar *out,
                                    global uchar2 *in) {
    uchar2 tmp = (uchar2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global uchar *out,
                             global uchar4 *in) {
    uchar4 tmp = in[0];
    vstore4((uchar4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global uchar *out,
                                    global uchar4 *in) {
    uchar4 tmp = (uchar4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global uchar *out,
                             global uchar8 *in) {
    uchar8 tmp = in[0];
    vstore8((uchar8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global uchar *out,
                                    global uchar8 *in) {
    uchar8 tmp = (uchar8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global uchar *out,
                             global uchar16 *in) {
    uchar16 tmp = in[0];
    vstore16((uchar16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global uchar *out,
                                    global uchar16 *in) {
    uchar16 tmp = (uchar16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
