
/*!
[config]
name: Vector store ulong2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global ulong2
kernel_name: vstore2_global
arg_out: 0 buffer ulong[3] 0 28 46
arg_in:  1 buffer ulong2[1] 28 46

[test]
name: vector store global offset ulong2
kernel_name: vstore2_global_offset
arg_out: 0 buffer ulong[5] 0 0 0  28 46
arg_in:  1 buffer ulong2[1] 28 46

[test]
name: vector store global ulong4
kernel_name: vstore4_global
arg_out: 0 buffer ulong[5] 0 120 155 52 202
arg_in:  1 buffer ulong4[1] 120 155 52 202

[test]
name: vector store global offset ulong4
kernel_name: vstore4_global_offset
arg_out: 0 buffer ulong[9] 0 0 0 0 0  120 155 52 202
arg_in:  1 buffer ulong4[1] 120 155 52 202

[test]
name: vector store global ulong8
kernel_name: vstore8_global
arg_out: 0 buffer ulong[9] 0 116 189 192 64 98 22 43 70
arg_in:  1 buffer ulong8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global offset ulong8
kernel_name: vstore8_global_offset
arg_out: 0 buffer ulong[17] 0 0 0 0 0 0 0 0 0  116 189 192 64 98 22 43 70
arg_in:  1 buffer ulong8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global ulong16
kernel_name: vstore16_global
arg_out: 0 buffer ulong[17] 0 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer ulong16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

[test]
name: vector store global offset ulong16
kernel_name: vstore16_global_offset
arg_out: 0 buffer ulong[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer ulong16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

!*/

kernel void vstore2_global(global ulong *out,
                             global ulong2 *in) {
    ulong2 tmp = in[0];
    vstore2((ulong2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global ulong *out,
                                    global ulong2 *in) {
    ulong2 tmp = (ulong2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global ulong *out,
                             global ulong4 *in) {
    ulong4 tmp = in[0];
    vstore4((ulong4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global ulong *out,
                                    global ulong4 *in) {
    ulong4 tmp = (ulong4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global ulong *out,
                             global ulong8 *in) {
    ulong8 tmp = in[0];
    vstore8((ulong8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global ulong *out,
                                    global ulong8 *in) {
    ulong8 tmp = (ulong8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global ulong *out,
                             global ulong16 *in) {
    ulong16 tmp = in[0];
    vstore16((ulong16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global ulong *out,
                                    global ulong16 *in) {
    ulong16 tmp = (ulong16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
