
/*!
[config]
name: Vector store ushort2,4,8,16
clc_version_min: 10

dimensions: 1
global_size: 1 0 0

[test]
name: vector store global ushort2
kernel_name: vstore2_global
arg_out: 0 buffer ushort[3] 0 28 46
arg_in:  1 buffer ushort2[1] 28 46

[test]
name: vector store global offset ushort2
kernel_name: vstore2_global_offset
arg_out: 0 buffer ushort[5] 0 0 0  28 46
arg_in:  1 buffer ushort2[1] 28 46

[test]
name: vector store global ushort4
kernel_name: vstore4_global
arg_out: 0 buffer ushort[5] 0 120 155 52 202
arg_in:  1 buffer ushort4[1] 120 155 52 202

[test]
name: vector store global offset ushort4
kernel_name: vstore4_global_offset
arg_out: 0 buffer ushort[9] 0 0 0 0 0  120 155 52 202
arg_in:  1 buffer ushort4[1] 120 155 52 202

[test]
name: vector store global ushort8
kernel_name: vstore8_global
arg_out: 0 buffer ushort[9] 0 116 189 192 64 98 22 43 70
arg_in:  1 buffer ushort8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global offset ushort8
kernel_name: vstore8_global_offset
arg_out: 0 buffer ushort[17] 0 0 0 0 0 0 0 0 0  116 189 192 64 98 22 43 70
arg_in:  1 buffer ushort8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store global ushort16
kernel_name: vstore16_global
arg_out: 0 buffer ushort[17] 0 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer ushort16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

[test]
name: vector store global offset ushort16
kernel_name: vstore16_global_offset
arg_out: 0 buffer ushort[33] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171
arg_in:  1 buffer ushort16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

!*/

kernel void vstore2_global(global ushort *out,
                             global ushort2 *in) {
    ushort2 tmp = in[0];
    vstore2((ushort2)0, 0, out);
    vstore2(tmp, 0, out + 1);
}

kernel void vstore2_global_offset(global ushort *out,
                                    global ushort2 *in) {
    ushort2 tmp = (ushort2)0;
    vstore2(tmp, 0, out);
    vstore2(tmp, 0, out + 1);
    tmp = in[0];
    vstore2(tmp, 1, out + 1);
}

kernel void vstore4_global(global ushort *out,
                             global ushort4 *in) {
    ushort4 tmp = in[0];
    vstore4((ushort4)0, 0, out);
    vstore4(tmp, 0, out + 1);
}

kernel void vstore4_global_offset(global ushort *out,
                                    global ushort4 *in) {
    ushort4 tmp = (ushort4)0;
    vstore4(tmp, 0, out);
    vstore4(tmp, 0, out + 1);
    tmp = in[0];
    vstore4(tmp, 1, out + 1);
}

kernel void vstore8_global(global ushort *out,
                             global ushort8 *in) {
    ushort8 tmp = in[0];
    vstore8((ushort8)0, 0, out);
    vstore8(tmp, 0, out + 1);
}

kernel void vstore8_global_offset(global ushort *out,
                                    global ushort8 *in) {
    ushort8 tmp = (ushort8)0;
    vstore8(tmp, 0, out);
    vstore8(tmp, 0, out + 1);
    tmp = in[0];
    vstore8(tmp, 1, out + 1);
}

kernel void vstore16_global(global ushort *out,
                             global ushort16 *in) {
    ushort16 tmp = in[0];
    vstore16((ushort16)0, 0, out);
    vstore16(tmp, 0, out + 1);
}

kernel void vstore16_global_offset(global ushort *out,
                                    global ushort16 *in) {
    ushort16 tmp = (ushort16)0;
    vstore16(tmp, 0, out);
    vstore16(tmp, 0, out + 1);
    tmp = in[0];
    vstore16(tmp, 1, out + 1);
}
