/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * require_extensions: GL_ARB_gpu_shader_fp64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * floor(dvec2(-2.0lf, -0.66666666666666674lf)) => dvec2(-2.0lf, -1.0lf)
 * floor(dvec2(0.66666666666666652lf, 2.0lf)) => dvec2(0.0lf, 2.0lf)
 */
#version 150
#extension GL_ARB_gpu_shader_fp64 : require

void main()
{
  double[distance(floor(dvec2(-2.0lf, -0.66666666666666674lf)), dvec2(-2.0lf, -1.0lf)) <= 2.2360679774997898e-05lf ? 1 : -1] array0;
  double[distance(floor(dvec2(0.66666666666666652lf, 2.0lf)), dvec2(0.0lf, 2.0lf)) <= 2.0000000000000002e-05lf ? 1 : -1] array1;
  gl_Position = vec4(array0.length() + array1.length());
}
