/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * require_extensions: ARB_gpu_shader_int64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * clamp(i64vec3(-20l, -6l, 6l), -15l, -15l) => i64vec3(-15l, -15l, -15l)
 * clamp(i64vec3(20l, -20l, -6l), -15l, -15l) => i64vec3(-15l, -15l, -15l)
 * clamp(i64vec3(-20l, -6l, 6l), -15l, 0l) => i64vec3(-15l, -6l, 0l)
 * clamp(i64vec3(20l, -20l, -6l), -15l, 0l) => i64vec3(0l, -15l, -6l)
 * clamp(i64vec3(-20l, -6l, 6l), -15l, 15l) => i64vec3(-15l, -6l, 6l)
 * clamp(i64vec3(20l, -20l, -6l), -15l, 15l) => i64vec3(15l, -15l, -6l)
 * clamp(i64vec3(-20l, -6l, 6l), 0l, 0l) => i64vec3(0l, 0l, 0l)
 * clamp(i64vec3(20l, -20l, -6l), 0l, 0l) => i64vec3(0l, 0l, 0l)
 * clamp(i64vec3(-20l, -6l, 6l), 0l, 15l) => i64vec3(0l, 0l, 6l)
 * clamp(i64vec3(20l, -20l, -6l), 0l, 15l) => i64vec3(15l, 0l, 0l)
 * clamp(i64vec3(-20l, -6l, 6l), 15l, 15l) => i64vec3(15l, 15l, 15l)
 * clamp(i64vec3(20l, -20l, -6l), 15l, 15l) => i64vec3(15l, 15l, 15l)
 */
#version 400
#extension GL_ARB_gpu_shader_int64 : require

void main()
{
  float[all(equal(clamp(i64vec3(-20l, -6l, 6l), -15l, -15l), i64vec3(-15l, -15l, -15l))) ? 1 : -1] array0;
  float[all(equal(clamp(i64vec3(20l, -20l, -6l), -15l, -15l), i64vec3(-15l, -15l, -15l))) ? 1 : -1] array1;
  float[all(equal(clamp(i64vec3(-20l, -6l, 6l), -15l, 0l), i64vec3(-15l, -6l, 0l))) ? 1 : -1] array2;
  float[all(equal(clamp(i64vec3(20l, -20l, -6l), -15l, 0l), i64vec3(0l, -15l, -6l))) ? 1 : -1] array3;
  float[all(equal(clamp(i64vec3(-20l, -6l, 6l), -15l, 15l), i64vec3(-15l, -6l, 6l))) ? 1 : -1] array4;
  float[all(equal(clamp(i64vec3(20l, -20l, -6l), -15l, 15l), i64vec3(15l, -15l, -6l))) ? 1 : -1] array5;
  float[all(equal(clamp(i64vec3(-20l, -6l, 6l), 0l, 0l), i64vec3(0l, 0l, 0l))) ? 1 : -1] array6;
  float[all(equal(clamp(i64vec3(20l, -20l, -6l), 0l, 0l), i64vec3(0l, 0l, 0l))) ? 1 : -1] array7;
  float[all(equal(clamp(i64vec3(-20l, -6l, 6l), 0l, 15l), i64vec3(0l, 0l, 6l))) ? 1 : -1] array8;
  float[all(equal(clamp(i64vec3(20l, -20l, -6l), 0l, 15l), i64vec3(15l, 0l, 0l))) ? 1 : -1] array9;
  float[all(equal(clamp(i64vec3(-20l, -6l, 6l), 15l, 15l), i64vec3(15l, 15l, 15l))) ? 1 : -1] array10;
  float[all(equal(clamp(i64vec3(20l, -20l, -6l), 15l, 15l), i64vec3(15l, 15l, 15l))) ? 1 : -1] array11;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length());
}
