/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * require_extensions: ARB_gpu_shader_int64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (u64vec2(10ul, 12ul) + 0ul) => u64vec2(10ul, 12ul)
 * (u64vec2(10ul, 12ul) + 10ul) => u64vec2(20ul, 22ul)
 * (u64vec2(10ul, 12ul) + 100000000000ul) => u64vec2(100000000010ul, 100000000012ul)
 * (u64vec2(42ul, 48ul) + 0ul) => u64vec2(42ul, 48ul)
 * (u64vec2(42ul, 48ul) + 10ul) => u64vec2(52ul, 58ul)
 * (u64vec2(42ul, 48ul) + 100000000000ul) => u64vec2(100000000042ul, 100000000048ul)
 */
#version 400
#extension GL_ARB_gpu_shader_int64 : require

void main()
{
  float[all(equal((u64vec2(10ul, 12ul) + 0ul), u64vec2(10ul, 12ul))) ? 1 : -1] array0;
  float[all(equal((u64vec2(10ul, 12ul) + 10ul), u64vec2(20ul, 22ul))) ? 1 : -1] array1;
  float[all(equal((u64vec2(10ul, 12ul) + 100000000000ul), u64vec2(100000000010ul, 100000000012ul))) ? 1 : -1] array2;
  float[all(equal((u64vec2(42ul, 48ul) + 0ul), u64vec2(42ul, 48ul))) ? 1 : -1] array3;
  float[all(equal((u64vec2(42ul, 48ul) + 10ul), u64vec2(52ul, 58ul))) ? 1 : -1] array4;
  float[all(equal((u64vec2(42ul, 48ul) + 100000000000ul), u64vec2(100000000042ul, 100000000048ul))) ? 1 : -1] array5;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length());
}
