/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * require_extensions: ARB_gpu_shader_int64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (0ul / u64vec2(10ul, 12ul)) => u64vec2(0ul, 0ul)
 * (0ul / u64vec2(42ul, 48ul)) => u64vec2(0ul, 0ul)
 * (10ul / u64vec2(10ul, 12ul)) => u64vec2(1ul, 0ul)
 * (10ul / u64vec2(42ul, 48ul)) => u64vec2(0ul, 0ul)
 * (100000000000ul / u64vec2(10ul, 12ul)) => u64vec2(10000000000ul, 8333333333ul)
 * (100000000000ul / u64vec2(42ul, 48ul)) => u64vec2(2380952380ul, 2083333333ul)
 */
#version 400
#extension GL_ARB_gpu_shader_int64 : require

void main()
{
  float[all(equal((0ul / u64vec2(10ul, 12ul)), u64vec2(0ul, 0ul))) ? 1 : -1] array0;
  float[all(equal((0ul / u64vec2(42ul, 48ul)), u64vec2(0ul, 0ul))) ? 1 : -1] array1;
  float[all(equal((10ul / u64vec2(10ul, 12ul)), u64vec2(1ul, 0ul))) ? 1 : -1] array2;
  float[all(equal((10ul / u64vec2(42ul, 48ul)), u64vec2(0ul, 0ul))) ? 1 : -1] array3;
  float[all(equal((100000000000ul / u64vec2(10ul, 12ul)), u64vec2(10000000000ul, 8333333333ul))) ? 1 : -1] array4;
  float[all(equal((100000000000ul / u64vec2(42ul, 48ul)), u64vec2(2380952380ul, 2083333333ul))) ? 1 : -1] array5;
  gl_FragColor = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length());
}
