/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * require_extensions: ARB_gpu_shader_int64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (0ul / u64vec4(165ul, 133ul, 193ul, 76ul)) => u64vec4(0ul, 0ul, 0ul, 0ul)
 * (10ul / u64vec4(165ul, 133ul, 193ul, 76ul)) => u64vec4(0ul, 0ul, 0ul, 0ul)
 * (100000000000ul / u64vec4(165ul, 133ul, 193ul, 76ul)) => u64vec4(606060606ul, 751879699ul, 518134715ul, 1315789473ul)
 */
#version 400
#extension GL_ARB_gpu_shader_int64 : require

void main()
{
  float[all(equal((0ul / u64vec4(165ul, 133ul, 193ul, 76ul)), u64vec4(0ul, 0ul, 0ul, 0ul))) ? 1 : -1] array0;
  float[all(equal((10ul / u64vec4(165ul, 133ul, 193ul, 76ul)), u64vec4(0ul, 0ul, 0ul, 0ul))) ? 1 : -1] array1;
  float[all(equal((100000000000ul / u64vec4(165ul, 133ul, 193ul, 76ul)), u64vec4(606060606ul, 751879699ul, 518134715ul, 1315789473ul))) ? 1 : -1] array2;
  gl_Position = vec4(array0.length() + array1.length() + array2.length());
}
