/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * require_extensions: ARB_gpu_shader_int64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (0ul / 10ul) => 0ul
 * (0ul / 100000000000ul) => 0ul
 * (10ul / 10ul) => 1ul
 * (10ul / 100000000000ul) => 0ul
 * (100000000000ul / 10ul) => 10000000000ul
 * (100000000000ul / 100000000000ul) => 1ul
 */
#version 400
#extension GL_ARB_gpu_shader_int64 : require

void main()
{
  float[(0ul / 10ul) == 0ul ? 1 : -1] array0;
  float[(0ul / 100000000000ul) == 0ul ? 1 : -1] array1;
  float[(10ul / 10ul) == 1ul ? 1 : -1] array2;
  float[(10ul / 100000000000ul) == 0ul ? 1 : -1] array3;
  float[(100000000000ul / 10ul) == 10000000000ul ? 1 : -1] array4;
  float[(100000000000ul / 100000000000ul) == 1ul ? 1 : -1] array5;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length());
}
