/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * require_extensions: ARB_gpu_shader_int64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (0l % i64vec3(167l, 66l, 187l)) => i64vec3(0l, 0l, 0l)
 * (100000000000l % i64vec3(167l, 66l, 187l)) => i64vec3(35l, 10l, 54l)
 */
#version 400
#extension GL_ARB_gpu_shader_int64 : require

void main()
{
  float[all(equal((0l % i64vec3(167l, 66l, 187l)), i64vec3(0l, 0l, 0l))) ? 1 : -1] array0;
  float[all(equal((100000000000l % i64vec3(167l, 66l, 187l)), i64vec3(35l, 10l, 54l))) ? 1 : -1] array1;
  gl_FragColor = vec4(array0.length() + array1.length());
}
