/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * require_extensions: ARB_gpu_shader_int64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (0l % i64vec4(165l, 133l, 193l, 76l)) => i64vec4(0l, 0l, 0l, 0l)
 * (100000000000l % i64vec4(165l, 133l, 193l, 76l)) => i64vec4(10l, 33l, 5l, 52l)
 */
#version 400
#extension GL_ARB_gpu_shader_int64 : require

void main()
{
  float[all(equal((0l % i64vec4(165l, 133l, 193l, 76l)), i64vec4(0l, 0l, 0l, 0l))) ? 1 : -1] array0;
  float[all(equal((100000000000l % i64vec4(165l, 133l, 193l, 76l)), i64vec4(10l, 33l, 5l, 52l))) ? 1 : -1] array1;
  gl_Position = vec4(array0.length() + array1.length());
}
