/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * require_extensions: ARB_gpu_shader_int64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (0ul >> 0u) => 0ul
 * (0ul >> 1u) => 0ul
 * (0ul >> 2u) => 0ul
 * (0ul >> 5u) => 0ul
 * (0ul >> 25u) => 0ul
 * (0ul >> 31u) => 0ul
 * (10ul >> 0u) => 10ul
 * (10ul >> 1u) => 5ul
 * (10ul >> 2u) => 2ul
 * (10ul >> 5u) => 0ul
 * (10ul >> 25u) => 0ul
 * (10ul >> 31u) => 0ul
 * (100000000000ul >> 0u) => 100000000000ul
 * (100000000000ul >> 1u) => 50000000000ul
 * (100000000000ul >> 2u) => 25000000000ul
 * (100000000000ul >> 5u) => 3125000000ul
 * (100000000000ul >> 25u) => 2980ul
 * (100000000000ul >> 31u) => 46ul
 */
#version 400
#extension GL_ARB_gpu_shader_int64 : require

void main()
{
  float[(0ul >> 0u) == 0ul ? 1 : -1] array0;
  float[(0ul >> 1u) == 0ul ? 1 : -1] array1;
  float[(0ul >> 2u) == 0ul ? 1 : -1] array2;
  float[(0ul >> 5u) == 0ul ? 1 : -1] array3;
  float[(0ul >> 25u) == 0ul ? 1 : -1] array4;
  float[(0ul >> 31u) == 0ul ? 1 : -1] array5;
  float[(10ul >> 0u) == 10ul ? 1 : -1] array6;
  float[(10ul >> 1u) == 5ul ? 1 : -1] array7;
  float[(10ul >> 2u) == 2ul ? 1 : -1] array8;
  float[(10ul >> 5u) == 0ul ? 1 : -1] array9;
  float[(10ul >> 25u) == 0ul ? 1 : -1] array10;
  float[(10ul >> 31u) == 0ul ? 1 : -1] array11;
  float[(100000000000ul >> 0u) == 100000000000ul ? 1 : -1] array12;
  float[(100000000000ul >> 1u) == 50000000000ul ? 1 : -1] array13;
  float[(100000000000ul >> 2u) == 25000000000ul ? 1 : -1] array14;
  float[(100000000000ul >> 5u) == 3125000000ul ? 1 : -1] array15;
  float[(100000000000ul >> 25u) == 2980ul ? 1 : -1] array16;
  float[(100000000000ul >> 31u) == 46ul ? 1 : -1] array17;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length() + array15.length() + array16.length() + array17.length());
}
